<?php

    ini_set('display_errors', 1);
    ini_set('display_startup_errors', 1);
    error_reporting(E_ALL);

	$this_tz_str = "Europe/Rome";
	$this_tz = new DateTimeZone($this_tz_str);
	$now = new DateTime("now", $this_tz);
	$offset = $this_tz->getOffset($now);

    echo "this_tz_str=$this_tz_str<br>";
    //echo "this_tz=$this_tz<br>";
    //echo "now=$now<br>";
    echo "offset=$offset<br>";

    /*$base = "../../../";
    require_once($base."config.php");
    echo "config<br>";
	require_once($base."scripts/functions.php");
    echo "functions<br>";
	require_once("calculateET.class.php");
    echo "class<br>";*/
    echo "calling evapo<br>";
	require_once("evapoTranspCalculate.php");
    echo "class<br>";
	echo "ET0=";
	echo calcET0(10,12,true,true,1) ."<br>"; 


function calcET1 ($defaultWindHeight,$defaultElevation,$elevationUnitMeters,$solarSensor,$nDaysAgo)
    {
    /*$defaultWindHeight = 10;
    $defaultElevation = 12;
	$elevationUnitMeters = true;
	$solarSensor = true;
	$nDaysAgo = 1;*/
	global $con;
	global $dataTempUnits;
	global $dataWindUnits;
	global $dataPressUnits;
	global $stationLat;
	
    $group = "GROUP BY YEAR(DateTime), MONTH(DateTime), DAY(DateTime) ";
    $span = "WHERE DATE(DateTime) = CURDATE() - INTERVAL ".$nDaysAgo." DAY ";

	if($solarSensor)
	    {$select = "SELECT avg(T), avg(H), avg(P), avg(S), avg(W), max(Tmax), min(Tmin)";}
    else
	    {$select = "SELECT avg(T), avg(H), avg(P), avg(W), max(Tmax), min(Tmin)";}
	$result = mysqli_query($con,
		$select . "
		FROM alldata " .
		$span .
		$group . "
		ORDER BY DateTime Desc
		");
	echo 
		$select . "
		FROM alldata " .
		$span .
		$group . "
		ORDER BY DateTime Desc
		<br>";
	echo "error:".mysqli_error($con)."<br>";
    $i = 0;
	while($row = mysqli_fetch_array($result))
		{
		echo "fetch: $i<br>";
		print_r($row); echo "<br>";
		$t[] = convertor1($row['avg(T)'],$dataTempUnits,"c");
		$h[] = $row['avg(H)'];
		$w[] = convertor1($row['avg(W)'],$dataWindUnits,"m/s");
		$p[] = convertor1($row['avg(P)'],$dataPressUnits,"kpa");
		$tmax[] = convertor1($row['max(Tmax)'],$dataTempUnits,"c");
		$tmin[] = convertor1($row['min(Tmin)'],$dataTempUnits,"c");
		if($solarSensor)
		    {$s[] = $row['avg(S)'];}
		else
		    {$s[] = 0;}
		$n[] = "ETo(-$i $refPeriod)";
		$i1 = $i+$nDaysAgo;
		$refDate[] =  date("Y-m-d", strtotime("-$i1 day"));
		echo "refdate={$refDate[$i]}<br>";
		echo "t={$t[$i]}<br>";
		$i++;
	    }

	if	(!$elevationUnitMeters)
		{$defaultElevation = convertor($defaultElevation,"ft","m");}
	for ($i=0; $i<count($t); $i++)
	    {
	    echo "run: $i<br>";
	    // variables
	    $Tavg = $t[$i];		            //$_GET['avgT']; // air temperature (C)
	    $Havg = $h[$i]; 	            //$_GET['avgH']; // relative humidity (%)
	    $Wavg = $w[$i];		            //$_GET['avgW']; // wind speed (m/s)
	    $Pavg = $p[$i];		            //$_GET['avgP']; // pressure (kPa) - optional
	    //  $WHeight = $defaultWindHeight;	//$_GET['wH']; // wind speed height measurement (m)
        //	$elevation = $_GET['alt']; 	// elevation (m above sea level)	// elevation defined as parameter
	    $date = $refDate[$i];		    //$_GET['date'];
	    $lat =  $stationLat;		    //$_GET['lat']; // latitude
	    $Savg = $s[$i];	                //$_GET['s']; // average daily solar radiation (W/m2)
	    
	    echo "yesterday: T=$Tavg  H=$Havg  W=$Wavg  P=$Pavg  WH=$defaultWindHeight  E=$defaultElevation  Date=$date  Lat=$lat  S=$Savg<br>";
	    $current = new calculateET($Tavg, $Havg, $Wavg, $Pavg, $defaultWindHeight, $defaultElevation, $date, $lat, $Savg);
	    if ($Savg == 0)
	        {$current->set_Rs($tmax[$i]-$tmin[$i]);}
	
	    $et[$i] = $current->get_ET();
	    $etInch[$i] = convertor($et[$i],"mm","in");
	    //$et = 1.234;	// for debug

	    $resultET[$i]['et'] = $current->get_ET();
	    $resultET[$i]['et1'] = $current->get_ET1();
	    $resultET[$i]['et2'] = $current->get_ET2();
	    $resultET[$i]['D'] = $current->get_D();
	    $resultET[$i]['g'] = $current->get_g();
	    $resultET[$i]['es'] = $current->get_es();
	    $resultET[$i]['ea'] = $current->get_ea();
	    $resultET[$i]['vpd'] = $current->get_vpd();
	    $resultET[$i]['J'] = $current->get_dayOfYear();
	    $resultET[$i]['dr'] = $current->get_dr();
	    $resultET[$i]['d'] = $current->get_declination();
	    $resultET[$i]['ws'] = $current->get_ws();
	    $resultET[$i]['Ra'] = $current->get_Ra();
	    $resultET[$i]['N'] = $current->get_N();
	    $resultET[$i]['Rso'] = $current->get_Rso();
	    $resultET[$i]['Rns'] = $current->get_Rns();
	    $resultET[$i]['Rnl'] = $current->get_Rnl();
	    $resultET[$i]['Rn'] = $current->get_Rn();
	
	    $resultET[$i]['inputT'] = $Tavg;
	    $resultET[$i]['inputTmax'] = $tmax[$i];
	    $resultET[$i]['inputTmin'] = $tmin[$i];
	    $resultET[$i]['inputH'] = $Havg;
	    $resultET[$i]['inputP'] = $Pavg;
	    $resultET[$i]['inputW'] = $Wavg;
	    $resultET[$i]['inputWh'] = $defaultWindHeight;
	    $resultET[$i]['inputS'] = $Savg;
	    $resultET[$i]['inputAlt'] = $defaultElevation;
	    $resultET[$i]['inputLat'] = $lat;
	    $resultET[$i]['inputDate'] = $date;
	    //print json_encode($resultET[$i]);
	    //print_r($resultET[$i]); echo "<br>";
	    echo "ET0 ($date) = {$resultET[$i]['et']}<br>";
	    }
	return $current->get_ET();
    }


	function convertor2($n,$unit1,$unit2){
		// prepare input
		$unit1 = trim(strtolower($unit1));
		$unit2 = trim(strtolower($unit2));
		$unit1 = str_replace("/","",$unit1);
		$unit2 = str_replace("/","",$unit2);
		$unit1 = str_replace("kts","kt",$unit1);
		$unit2 = str_replace("kts","kt",$unit2);
		$unit1 = str_replace("knots","kt",$unit1);
		$unit2 = str_replace("knots","kt",$unit2);
		$unit1 = str_replace("kph","kmh",$unit1);
		$unit2 = str_replace("kph","kmh",$unit2);
		$unit1 = str_replace("mb","hpa",$unit1);
		$unit2 = str_replace("mb","hpa",$unit2);
		$unit1 = str_replace("miles","mi",$unit1);
		$unit2 = str_replace("miles","mi",$unit2);
		$unit1 = str_replace("feet","ft",$unit1);
		$unit2 = str_replace("feet","ft",$unit2);
		$unit1 = str_replace("foot","ft",$unit1);
		$unit2 = str_replace("foot","ft",$unit2);

		// return same units
		if($unit1==$unit2){
			return $n;
		}

		// temperature
		else if($unit1=="c" && $unit2=="f"){
			return $n*1.8 + 32;
		}
		else if($unit1=="f" && $unit2=="c"){
			return ($n - 32)/1.8;
		}

		// wind speed
		else if($unit1=="ms" && $unit2=="kmh"){
			return $n * 3.6;
		}
		else if($unit1=="ms" && $unit2=="mph"){
			return $n * 2.23694;
		}
		else if($unit1=="ms" && $unit2=="kt"){
			return $n * 1.943844;
		}
		else if($unit1=="kmh" && $unit2=="ms"){
			return $n / 3.6;
		}
		else if($unit1=="kmh" && $unit2=="mph"){
			return $n * 0.621371;
		}
		else if($unit1=="kmh" && $unit2=="kt"){
			return $n * 0.539957;
		}
		else if($unit1=="mph" && $unit2=="ms"){
			return $n * 0.44704;
		}
		else if($unit1=="mph" && $unit2=="kmh"){
			return $n * 1.609344;
		}
		else if($unit1=="mph" && $unit2=="kt"){
			return $n * 0.868976;
		}
		else if($unit1=="kt" && $unit2=="ms"){
			return $n * 0.514444;
		}
		else if($unit1=="kt" && $unit2=="kmh"){
			return $n * 1.852;
		}
		else if($unit1=="kt" && $unit2=="mph"){
			return $n * 1.150779;
		}

		// pressure
		else if($unit1=="hpa" && $unit2=="kpa"){
			return $n * 0.1;
		}
		else if($unit1=="hpa" && $unit2=="inhg"){
			return $n * 0.02952998;
		}
		else if($unit1=="hpa" && $unit2=="mmhg"){
			return $n * 0.750063755;
		}
		else if($unit1=="inhg" && $unit2=="hpa"){
			return $n * 33.863881;
		}
		else if($unit1=="inhg" && $unit2=="mmhg"){
			return $n * 25.400069;
		}
		else if($unit1=="mmhg" && $unit2=="hpa"){
			return $n * 1.3332239;
		}
		else if($unit1=="mmhg" && $unit2=="inhg"){
			return $n * 0.03937;
		}

		// precipitation
		else if($unit1=="mm" && $unit2=="in"){
			return $n * 0.0393701;
		}
		else if($unit1=="in" && $unit2=="mm"){
			return $n * 25.4;
		}

		else if($unit1=="mm" && $unit2=="cm"){
			return $n * 0.1;
		}
		else if($unit1=="cm" && $unit2=="mm"){
			return $n * 10;
		}

		// distance
		else if($unit1=="km" && $unit2=="mi"){
			return $n * 0.621371;
		}
		else if($unit1=="mi" && $unit2=="km"){
			return $n * 1.60934;
		}
		else if($unit1=="km" && $unit2=="ft"){
			return $n * 3280.84;
		}
		else if($unit1=="ft" && $unit2=="km"){
			return $n * 0.0003048;
		}
		else if($unit1=="m" && $unit2=="ft"){
			return $n * 3.28084;
		}
		else if($unit1=="ft" && $unit2=="m"){
			return $n * 0.3048;
		}
	}
?>